Loading...
Searching...
No Matches
auxiliary.h File Reference

All the auxiliary stuff. More...

`#include "libpolysconfig.h"`
`#include "factory/globaldefs.h"`
`#include <sys/types.h>`

Go to the source code of this file.

## Macros

#define | SI_INTEGER_VARIANT 2
#define | SI_BIGINT_VARIANT 1
#define | CHAR_BIT (8)
#define | BIT_SIZEOF_LONG ((CHAR_BIT)*(SIZEOF_LONG))
#define | BITSET unsigned int
#define | FALSE 0
#define | TRUE 1
#define | NULL (0)
#define | NULLp ((void*)NULL)
#define | loop for(;;)
#define | SSI_BASE 16
#define | NO_INLINE
#define | PDEBUG 0
#define | KDEBUG 0
#define | LDEBUG
#define | RDEBUG
#define | TEST
#define | YYDEBUG 1
#define | FORCE_INLINE inline
#define | DO_PRAGMA(x)
#define | TODO(who, msg)
#define | _GNUC_PREREQ(maj, min)
#define | FORCE_INTERNAL
#define | FORCE_DEPRECATED
#define | BEGIN_CDECL extern "C" {
#define | END_CDECL }
#define | LIKELY(X)
#define | UNLIKELY(X)

## Typedefs

typedef long | int64
typedef int | BOOLEAN
typedef void * | ADDRESS

## Functions

static int | ABS (int v)
static int | si_max (const int a, const int b)
static int | si_min (const int a, const int b)
static long | si_max (const long a, const long b)
static unsigned long | si_max (const unsigned long a, const unsigned long b)
static long | si_min (const long a, const long b)
static unsigned long | si_min (const unsigned long a, const unsigned long b)
template<typename A, typename B>
B | cast_A_to_B (A a)
template<typename A>
void * | cast_A_to_vptr (A a)
template<typename A>
A | cast_vptr_to_A (void *p)

## Detailed Description

All the auxiliary stuff.

ABSTRACT: we shall put here everything that does not have its own place.

Author
  Oleksandr Motsak

Definition in file auxiliary.h.

## Macro Definition Documentation

## _GNUC_PREREQ

#define _GNUC_PREREQ | ( |  | maj,
|  |  | min )

Value:
0

Definition at line 345 of file auxiliary.h.

## BEGIN_CDECL

#define BEGIN_CDECL extern "C" {

Definition at line 361 of file auxiliary.h.

## BIT_SIZEOF_LONG

#define BIT_SIZEOF_LONG ((CHAR_BIT)*(SIZEOF_LONG))

Definition at line 80 of file auxiliary.h.

## BITSET

#define BITSET unsigned int

Definition at line 85 of file auxiliary.h.

## CHAR_BIT

#define CHAR_BIT (8)

Definition at line 75 of file auxiliary.h.

## DO_PRAGMA

#define DO_PRAGMA | ( |  | x | ) |

Value:
_Pragma (#x)
x
Variable x
Definition cfModGcd.cc:4090

Definition at line 337 of file auxiliary.h.

## END_CDECL

#define END_CDECL }

Definition at line 362 of file auxiliary.h.

## FALSE

#define FALSE 0

Definition at line 97 of file auxiliary.h.

## FORCE_DEPRECATED

#define FORCE_DEPRECATED

Definition at line 357 of file auxiliary.h.

## FORCE_INLINE

#define FORCE_INLINE inline

Definition at line 330 of file auxiliary.h.

## FORCE_INTERNAL

#define FORCE_INTERNAL

Definition at line 351 of file auxiliary.h.

## KDEBUG

#define KDEBUG 0

Definition at line 299 of file auxiliary.h.

## LDEBUG

#define LDEBUG

Definition at line 302 of file auxiliary.h.

## LIKELY

#define LIKELY | ( |  | X | ) |

Value:
(X)

Definition at line 404 of file auxiliary.h.

## loop

#define loop for(;;)

Definition at line 122 of file auxiliary.h.

## NO_INLINE

#define NO_INLINE

Definition at line 148 of file auxiliary.h.

## NULL

#define NULL (0)

Definition at line 105 of file auxiliary.h.

## NULLp

#define NULLp ((void*)NULL)

Definition at line 109 of file auxiliary.h.

## PDEBUG

#define PDEBUG 0

Definition at line 171 of file auxiliary.h.

## RDEBUG

#define RDEBUG

Definition at line 305 of file auxiliary.h.

## SI_BIGINT_VARIANT

#define SI_BIGINT_VARIANT 1

Definition at line 38 of file auxiliary.h.

## SI_INTEGER_VARIANT

#define SI_INTEGER_VARIANT 2

Definition at line 34 of file auxiliary.h.

## SSI_BASE

#define SSI_BASE 16

Definition at line 136 of file auxiliary.h.

## TEST

#define TEST

Definition at line 308 of file auxiliary.h.

## TODO

#define TODO | ( |  | who,
|  |  | msg )

Value:
DO_PRAGMA(message ("TODO [for " #who "]: " #msg))
DO_PRAGMA
#define DO_PRAGMA(x)
Definition auxiliary.h:337
message
void message(int i, int *olddeg, int *reduc, kStrategy strat, int red_result)
Definition kutil.cc:7463

Definition at line 338 of file auxiliary.h.

## TRUE

#define TRUE 1

Definition at line 101 of file auxiliary.h.

## UNLIKELY

#define UNLIKELY | ( |  | X | ) |

Value:
(X)

Definition at line 405 of file auxiliary.h.

## YYDEBUG

#define YYDEBUG 1

Definition at line 311 of file auxiliary.h.

## Typedef Documentation

## ADDRESS

typedef void* ADDRESS

Definition at line 120 of file auxiliary.h.

## BOOLEAN

typedef int BOOLEAN

Definition at line 88 of file auxiliary.h.

## int64

typedef long int64

Definition at line 68 of file auxiliary.h.

## Function Documentation

## ABS()

int ABS | ( | int | v | ) |

inline static

Definition at line 113 of file auxiliary.h.

{
int const mask = v >> (sizeof(int) * CHAR_BIT - 1);
return ((v + mask) ^ mask);
}
CHAR_BIT
#define CHAR_BIT
Definition auxiliary.h:75
v
const Variable & v
< [in] a sqrfree bivariate poly
Definition facBivar.h:39

## cast_A_to_B()

template<typename A, typename B>

B cast_A_to_B | ( | A | a | ) |

inline

Definition at line 373 of file auxiliary.h.

{
union
{
A a;
B b;
} u;
u.a = a;
return u.b;
}
b
CanonicalForm b
Definition cfModGcd.cc:4111
B
b *CanonicalForm B
Definition facBivar.cc:52
A
#define A
Definition sirandom.c:24

## cast_A_to_vptr()

template<typename A>

void * cast_A_to_vptr | ( | A | a | ) |

inline

Definition at line 386 of file auxiliary.h.

{
return cast_A_to_B<A, void*>(a);
}
cast_A_to_B
B cast_A_to_B(A a)
Definition auxiliary.h:373

## cast_vptr_to_A()

template<typename A>

A cast_vptr_to_A | ( | void * | p | ) |

inline

Definition at line 393 of file auxiliary.h.

{
return cast_A_to_B<void*, A>(p);
}
p
int p
Definition cfModGcd.cc:4086

## si_max() [1/3]

int si_max | ( | const int | a,
|  | const int | b )

inline static

Definition at line 125 of file auxiliary.h.

{ return (a>b) ? a : b; }

## si_max() [2/3]

long si_max | ( | const long | a,
|  | const long | b )

inline static

Definition at line 127 of file auxiliary.h.

{ return (a>b) ? a : b; }

## si_max() [3/3]

unsigned long si_max | ( | const unsigned long | a,
|  | const unsigned long | b )

inline static

Definition at line 128 of file auxiliary.h.

{ return (a>b) ? a : b; }

## si_min() [1/3]

int si_min | ( | const int | a,
|  | const int | b )

inline static

Definition at line 126 of file auxiliary.h.

{ return (a<b) ? a : b; }

## si_min() [2/3]

long si_min | ( | const long | a,
|  | const long | b )

inline static

Definition at line 129 of file auxiliary.h.

{ return (a<b) ? a : b; }

## si_min() [3/3]

unsigned long si_min | ( | const unsigned long | a,
|  | const unsigned long | b )

inline static

Definition at line 130 of file auxiliary.h.

{ return (a<b) ? a : b; }